Require Import logic.
Definition transitive : forall (A:Type), (A -> A -> Prop) -> Prop := fun (A:Type) => fun (R:(A -> A -> Prop)) => forall (x:A), forall (y:A), forall (z:A), (R x y) -> (R y z) -> R x z.
Definition commutative : forall (A:Type), (A -> A -> A) -> Prop := fun (A:Type) => fun (f:(A -> A -> A)) => forall (x:A), forall (y:A), logic.eq (A) (f x y) (f y x).
Definition associative : forall (A:Type), (A -> A -> A) -> Prop := fun (A:Type) => fun (f:(A -> A -> A)) => forall (x:A), forall (y:A), forall (z:A), logic.eq (A) (f (f x y) z) (f x (f y z)).
Definition monotonic : forall (A:Type), (A -> A -> Prop) -> (A -> A) -> Prop := fun (A:Type) => fun (R:(A -> A -> Prop)) => fun (f:(A -> A)) => forall (x:A), forall (y:A), (R x y) -> R (f x) (f y).
