Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Parameter minus : nat -> nat -> nat.
Parameter minus_body : nat -> nat -> nat.
Axiom axiom_minus : forall (n:nat), connectives.equal (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n).
Definition eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((axiom_minus) (n)).
Definition sym_eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) minus_body n) (minus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((eq_minus) (n)).
Axiom axiom_minus_body_O : connectives.equal (nat -> nat) (minus_body O) (fun (m:nat) => O).
Definition eq_minus_body_O : leibniz.leibniz (nat -> nat) (minus_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (axiom_minus_body_O).
Definition sym_eq_minus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (minus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (eq_minus_body_O).
Axiom axiom_minus_body_S : forall (n:nat), connectives.equal (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m).
Definition eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((axiom_minus_body_S) (n)).
Definition sym_eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) (minus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((eq_minus_body_S) (n)).
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition plus_O_n : forall (n:nat), logic.eq (nat) n (plus O n) := fun (n:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((logic.refl) (nat)) (n)))).
Definition plus_n_O : forall (n:nat), logic.eq (nat) n (plus n O) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) _x_365 (plus _x_365 O))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) x_366 (plus x_366 O)) => ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) (((((((logic.rewrite_l) (nat)) (x_366)) (fun (__:nat) => logic.eq (nat) (S x_366) (S __))) (((logic.refl) (nat)) (S x_366))) (plus x_366 O)) (_x_368))))))) (n).
Definition plus_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (S (plus n m)) (plus n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (S (plus _x_365 m)) (plus _x_365 (S m)))) (fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus O (S m)))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S m) (y (S m)))) (((logic.refl) (nat)) (S m))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (S (plus x_366 m)) (plus x_366 (S m))) => (fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus (S x_366) (S m)))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (S (plus x_366 m))) (y (S m)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) __ (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (S (S m))) __)) (((logic.refl) (nat)) (plus x_366 (S (S m))))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 m))) ((_x_368) (m))))))))))) (n).
Definition commutative_plus : relations.commutative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), logic.eq (nat) (plus _x_365 y) (plus y _x_365))) (fun (y:nat) => (((sym_eq_plus) (O)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((sym_eq_plus_body_O) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((((logic.rewrite_l) (nat)) (y)) (fun (__:nat) => logic.eq (nat) y __)) (((logic.refl) (nat)) (y))) (plus y O)) ((plus_n_O) (y))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), logic.eq (nat) (plus x_366 y) (plus y x_366)) => (fun (y:nat) => (((sym_eq_plus) (S x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((sym_eq_plus_body_S) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y (S x_366))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((logic.refl) (nat)) (plus y (S x_366)))) (plus x_366 (S y))) (((((((logic.rewrite_l) (nat)) (S (plus x_366 y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y x_366)) (fun (__:nat) => logic.eq (nat) (S __) (plus y (S x_366)))) (((plus_n_Sm) (y)) (x_366))) (plus x_366 y)) ((_x_368) (y)))) (plus x_366 (S y))) (((plus_n_Sm) (x_366)) (y))))) (S (plus x_366 y))) (((plus_n_Sm) (x_366)) (y)))))))) (n).
Definition associative_plus : relations.associative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus _x_365 y) z) (plus _x_365 (plus y z)))) (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus O y) z) (x (plus y z)))) ((((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (plus y z))) (((logic.refl) (nat)) (plus y z))))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus x_366 y) z) (plus x_366 (plus y z))) => (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus) (S (plus x_366 y))) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus_body_S) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (plus y z))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (plus y z))))) (((logic.refl) (nat)) (S (plus x_366 (plus y z))))) (plus (plus x_366 y) z)) (((_x_368) (y)) (z)))))))))))))) (n).
Definition minus_S_S : forall (n:nat), forall (m:nat), logic.eq (nat) (minus (S n) (S m)) (minus n m) := fun (n:nat) => fun (m:nat) => ((((((eq_match_nat_type_S) (nat)) (S n)) (fun (q:nat) => minus n q)) (m)) (fun (y:nat) => logic.eq (nat) (minus (S n) (S m)) y)) ((((eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) ((((((eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) ((((eq_minus) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) (((logic.refl) (nat)) (minus (S n) (S m)))))).
Definition minus_O_n : forall (n:nat), logic.eq (nat) O (minus O n) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) O (minus O __))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (fun (auto:nat) => ((logic.refl) (nat)) (O)))))) (n).
Definition minus_n_O : forall (n:nat), logic.eq (nat) n (minus n O) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) __ (minus __ O))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus O O)) ((minus_O_n) (O)))) (fun (auto:nat) => (((sym_eq_minus) (S auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((sym_eq_minus_body_S) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_match_nat_type_O) (nat)) (S auto)) (fun (q:nat) => minus auto q)) (fun (y:nat) => logic.eq (nat) (S auto) y)) (((logic.refl) (nat)) (S auto))))))) (n).
Definition minus_n_n : forall (n:nat), logic.eq (nat) O (minus n n) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) O (minus _x_365 _x_365))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus O O)) ((minus_O_n) (O)))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) O (minus x_366 x_366)) => (((((((logic.rewrite_r) (nat)) (minus x_366 x_366)) (fun (__:nat) => logic.eq (nat) O __)) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus x_366 x_366)) (_x_368))) (minus (S x_366) (S x_366))) (((minus_S_S) (x_366)) (x_366))))) (n).
Definition lt_to_not_zero : forall (n:nat), forall (m:nat), (lt n m) -> not_zero m := fun (n:nat) => fun (m:nat) => fun (Hlt:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => not_zero x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (fun (m0:nat) => fun (_x_419:le (S n) m0) => (fun (_x_421:not_zero m0) => (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (m0)) (fun (y:Prop) => y)) (connectives.I))))) (m)) (Hlt)).
Definition le_S_S : forall (n:nat), forall (m:nat), (le n m) -> le (S n) (S m) := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (S n) (S x_417))) ((le_n) (S n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (S n) (S m0)) => ((((le_S) (S n)) (S m0)) (_x_421))))) (m)) (lenm)).
Definition le_O_n : forall (n:nat), le O n := fun (n:nat) => ((((nat_ind) (le O)) ((le_n) (O))) (fun (x_366:nat) => fun (_x_368:le O x_366) => ((((le_S) (O)) (x_366)) (_x_368)))) (n).
Definition le_n_Sn : forall (n:nat), le n (S n) := fun (n:nat) => (((le_S) (n)) (n)) ((le_n) (n)).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition le_pred_n : forall (n:nat), le (pred n) n := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => le (pred _x_365) _x_365)) ((((((eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => le (match_nat_type (nat) O (fun (p:nat) => p) O) y)) ((le_n) (pred O)))) (fun (x_366:nat) => fun (_x_368:le (pred x_366) x_366) => (((((((eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (x_366)) (fun (y:nat) => le (pred (S x_366)) (S y))) ((le_n_Sn) (pred (S x_366)))))) (n).
Definition monotonic_pred : relations.monotonic (nat) le pred := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (pred n) (pred x_417))) ((le_n) (pred n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (pred n) (pred m0)) => ((((((transitive_le) (pred n)) (n)) (pred (S m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (m0)) (fun (y:nat) => le n y)) (_x_419)))))) (m)) (lenm)).
Definition monotonic_le_plus_r : forall (n:nat), relations.monotonic (nat) le (fun (m:nat) => plus n m) := fun (n:nat) => fun (a:nat) => fun (b:nat) => ((((nat_ind) (fun (_x_365:nat) => (le a b) -> le (plus _x_365 a) (plus _x_365 b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (plus O a) (y b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (y a) b)) (fun (auto:le a b) => (auto))))))))) (fun (m:nat) => fun (H:(le a b) -> le (plus m a) (plus m b)) => (fun (leab:le a b) => ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (plus (S m) a) (y b))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (y a) (S (plus m b)))) ((((le_S_S) (plus m a)) (plus m b)) ((H) (leab)))))))))))) (n).
Definition monotonic_le_plus_l : forall (m:nat), relations.monotonic (nat) le (fun (n:nat) => plus n m) := fun (m:nat) => fun (x:nat) => fun (y:nat) => fun (auto:le x y) => (((((logic.eq_coerc) (le (plus m x) (plus m y))) (le (plus x m) (plus y m))) (((((monotonic_le_plus_r) (m)) (x)) (y)) (auto))) (((((((logic.rewrite_r) (nat)) (plus m x)) (fun (__:nat) => logic.eq (Prop) (le (plus m x) (plus m y)) (le __ (plus y m)))) (((((((logic.rewrite_r) (nat)) (plus m y)) (fun (__:nat) => logic.eq (Prop) (le (plus m x) (plus m y)) (le (plus m x) __))) (((logic.refl) (Prop)) (le (plus m x) (plus m y)))) (plus y m)) (((commutative_plus) (y)) (m)))) (plus x m)) (((commutative_plus) (x)) (m)))).
Definition le_plus_n : forall (n:nat), forall (m:nat), le m (plus n m) := fun (n:nat) => fun (m:nat) => ((((logic.eq_coerc) (le (plus O m) (plus n m))) (le m (plus n m))) (((((monotonic_le_plus_l) (m)) (O)) (n)) ((le_O_n) (n)))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le __ (plus n m)) (le m (plus n m)))) (((logic.refl) (Prop)) (le m (plus n m)))) (plus O m)) ((plus_O_n) (m))).
Definition le_plus_n_r : forall (n:nat), forall (m:nat), le m (plus m n) := fun (n:nat) => fun (m:nat) => ((((logic.eq_coerc) (le m (plus n m))) (le m (plus m n))) (((le_plus_n) (n)) (m))) (((((((logic.rewrite_r) (nat)) (plus n m)) (fun (__:nat) => logic.eq (Prop) (le m (plus n m)) (le m __))) (((logic.refl) (Prop)) (le m (plus n m)))) (plus m n)) (((commutative_plus) (m)) (n))).
Definition le_plus_minus_m_m : forall (n:nat), forall (m:nat), le n (plus (minus n m) m) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), le _x_365 (plus (minus _x_365 m) m))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => forall (m:nat), le O (plus (y m) m))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => forall (m:nat), le O (plus (y m) m))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => forall (m:nat), le O (plus (y m) m))) (fun (m:nat) => ((le_plus_n_r) (m)) (O)))))) (fun (a:nat) => fun (Hind:forall (m:nat), le a (plus (minus a m) m)) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => le (S a) (plus (minus (S a) __) __))) ((((sym_eq_minus) (S a)) (fun (y:(nat -> nat)) => le (S a) (plus (y O) O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (a)) (fun (y:(nat -> nat)) => le (S a) (plus (y O) O))) ((((sym_eq_minus_body_S) (a)) (fun (y:(nat -> nat)) => le (S a) (plus (y O) O))) ((((((sym_eq_match_nat_type_O) (nat)) (S a)) (fun (q:nat) => minus a q)) (fun (y:nat) => le (S a) (plus y O))) (((le_plus_n_r) (O)) (S a))))))) (fun (n0:nat) => (((sym_eq_minus) (S a)) (fun (y:(nat -> nat)) => le (S a) (plus (y (S n0)) (S n0)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (a)) (fun (y:(nat -> nat)) => le (S a) (plus (y (S n0)) (S n0)))) ((((sym_eq_minus_body_S) (a)) (fun (y:(nat -> nat)) => le (S a) (plus (y (S n0)) (S n0)))) (((((((sym_eq_match_nat_type_S) (nat)) (S a)) (fun (q:nat) => minus a q)) (n0)) (fun (y:nat) => le (S a) (plus y (S n0)))) (((((logic.eq_coerc) (le (S a) (S (plus (minus a n0) n0)))) (le (S a) (plus (minus a n0) (S n0)))) ((((le_S_S) (a)) (plus (minus a n0) n0)) ((Hind) (n0)))) (((((((logic.rewrite_r) (nat)) (plus (minus a n0) (S n0))) (fun (__:nat) => logic.eq (Prop) (le (S a) __) (le (S a) (plus (minus a n0) (S n0))))) (((logic.refl) (Prop)) (le (S a) (plus (minus a n0) (S n0))))) (S (plus (minus a n0) n0))) (((plus_n_Sm) (minus a n0)) (n0))))))))) (m)))) (n).
Definition transitive_lt : relations.transitive (nat) lt := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (ltab:lt a b) => (fun (ltbc:lt b c) => (((((((le_ind) (S b)) (fun (x_417:nat) => lt a x_417)) ((((le_S) (S a)) (b)) (ltab))) (fun (m:nat) => fun (_x_419:le (S b) m) => (fun (_x_421:lt a m) => ((((le_S) (S a)) (m)) (_x_421))))) (c)) (ltbc))).
Definition lt_to_le_to_lt : forall (n:nat), forall (m:nat), forall (p:nat), (lt n m) -> (le m p) -> lt n p := fun (n:nat) => fun (m:nat) => fun (p:nat) => fun (H:lt n m) => (fun (H1:le m p) => (((((((le_ind) (m)) (fun (x_417:nat) => lt n x_417)) (H)) (fun (m0:nat) => fun (_x_419:le m m0) => (fun (_x_421:lt n m0) => ((((((transitive_lt) (n)) (m0)) (S m0)) (_x_421)) (((((logic.eq_coerc) (le (S m0) (plus O (S m0)))) (le (S m0) (S m0))) (((le_plus_n) (O)) (S m0))) (((((((logic.rewrite_l) (nat)) (S m0)) (fun (__:nat) => logic.eq (Prop) (le (S m0) __) (le (S m0) (S m0)))) (((logic.refl) (Prop)) (le (S m0) (S m0)))) (plus O (S m0))) ((plus_O_n) (S m0)))))))) (p)) (H1))).
Definition ltn_to_ltO : forall (n:nat), forall (m:nat), (lt n m) -> lt O m := fun (n:nat) => fun (m:nat) => fun (auto:lt n m) => ((((((lt_to_le_to_lt) (O)) (S n)) (m)) (((((logic.eq_coerc) (le (S O) (plus n (S O)))) (le (S O) (S n))) (((le_plus_n) (n)) (S O))) (((((((logic.rewrite_l) (nat)) (S n)) (fun (__:nat) => logic.eq (Prop) (le (S O) __) (le (S O) (S n)))) (((logic.refl) (Prop)) (le (S O) (S n)))) (plus n (S O))) (((((((logic.rewrite_r) (nat)) (plus n O)) (fun (__:nat) => logic.eq (nat) (S __) (plus n (S O)))) (((plus_n_Sm) (n)) (O))) (n)) ((plus_n_O) (n)))))) (auto)).
Definition lt_O_S : forall (n:nat), lt O (S n) := fun (n:nat) => (((ltn_to_ltO) (n)) (S n)) (((((logic.eq_coerc) (le (S n) (plus O (S n)))) (le (S n) (S n))) (((le_plus_n) (O)) (S n))) (((((((logic.rewrite_l) (nat)) (S n)) (fun (__:nat) => logic.eq (Prop) (le (S n) __) (le (S n) (S n)))) (((logic.refl) (Prop)) (le (S n) (S n)))) (plus O (S n))) ((plus_O_n) (S n)))).
Definition not_le_Sn_O : forall (n:nat), connectives.Not (le (S n) O) := fun (n:nat) => ((connectives.nmk) (le (S n) O)) (fun (Hlen0:le (S n) O) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) ((((lt_to_not_zero) (n)) (O)) (Hlen0)))).
Definition not_le_to_not_le_S_S : forall (n:nat), forall (m:nat), (connectives.Not (le n m)) -> connectives.Not (le (S n) (S m)) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (le n m)) => (((((logic.not_to_not) (le (S n) (S m))) (le n m)) (fun (auto':le (S n) (S m)) => (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) (auto'))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n)))))) (auto)).
Definition not_le_S_S_to_not_le : forall (n:nat), forall (m:nat), (connectives.Not (le (S n) (S m))) -> connectives.Not (le n m) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (le (S n) (S m))) => (((((logic.not_to_not) (le n m)) (le (S n) (S m))) (fun (auto':le n m) => ((((le_S_S) (n)) (m)) (auto')))) (auto)).
Definition not_le_to_lt : forall (n:nat), forall (m:nat), (connectives.Not (le n m)) -> lt m n := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => (connectives.Not (le __ _0)) -> lt _0 __)) (fun (n:nat) => fun (abs:connectives.Not (le O n)) => (((connectives.falsity) (lt n O)) ((((logic.absurd) (le O n)) (((((logic.eq_coerc) (le O (plus n O))) (le O n)) (((le_plus_n) (n)) (O))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le O __) (le O n))) (((logic.refl) (Prop)) (le O n))) (plus n O)) ((plus_n_O) (n))))) (abs))))) (fun (n:nat) => fun (auto:connectives.Not (le (S n) O)) => ((lt_O_S) (n)))) (fun (n:nat) => fun (m:nat) => fun (Hind:(connectives.Not (le n m)) -> lt m n) => (fun (HnotleSS:connectives.Not (le (S n) (S m))) => ((((le_S_S) (S m)) (n)) ((Hind) ((((not_le_S_S_to_not_le) (n)) (m)) (HnotleSS)))))).
Definition decidable_le : forall (n:nat), forall (m:nat), logic.decidable (le n m) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => logic.decidable (le __ _0))) (fun (n:nat) => (((connectives.or_introl) (le O n)) (connectives.Not (le O n))) ((le_O_n) (n)))) (fun (n:nat) => (((connectives.or_intror) (le (S n) O)) (connectives.Not (le (S n) O))) ((not_le_Sn_O) (n)))) (fun (n:nat) => fun (m:nat) => fun (_clearme:logic.decidable (le n m)) => (((((((connectives.match_Or_prop) (le n m)) (connectives.Not (le n m))) (logic.decidable (le (S n) (S m)))) (fun (auto:le n m) => ((((connectives.or_introl) (le (S n) (S m))) (connectives.Not (le (S n) (S m)))) ((((le_S_S) (n)) (m)) (auto))))) (fun (auto:connectives.Not (le n m)) => ((((connectives.or_intror) (le (S n) (S m))) (connectives.Not (le (S n) (S m)))) ((((not_le_to_not_le_S_S) (n)) (m)) (auto))))) (_clearme))).
Definition le_n_O_elim : forall (n:nat), (le n O) -> forall (P:(nat -> Prop)), (P O) -> P n := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => (le __ O) -> forall (P:(nat -> Prop)), (P O) -> P __)) (fun (auto:le O O) => (fun (P:nat -> Prop) => fun (auto':P O) => (auto')))) (fun (a:nat) => fun (abs:le (S a) O) => (((connectives.falsity) (forall (P:(nat -> Prop)), (P O) -> P (S a))) ((((logic.absurd) (le (S a) O)) (abs)) ((not_le_Sn_O) (a)))))) (n).
Definition plus_minus : forall (m:nat), forall (n:nat), forall (p:nat), (le m n) -> logic.eq (nat) (plus (minus n m) p) (minus (plus n p) m) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => forall (p:nat), (le __ _0) -> logic.eq (nat) (plus (minus _0 __) p) (minus (plus _0 p) __))) (fun (n:nat) => fun (p:nat) => fun (auto:le O n) => (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (nat) (plus __ p) (minus (plus n p) O))) (((((((logic.rewrite_l) (nat)) (plus n p)) (fun (__:nat) => logic.eq (nat) (plus n p) __)) (((logic.refl) (nat)) (plus n p))) (minus (plus n p) O)) ((minus_n_O) (plus n p)))) (minus n O)) ((minus_n_O) (n))))) (fun (n:nat) => fun (p:nat) => fun (abs:le (S n) O) => (((connectives.falsity) (logic.eq (nat) (plus (minus O (S n)) p) (minus (plus O p) (S n)))) ((((logic.absurd) (le (S n) O)) (abs)) ((not_le_Sn_O) (n)))))) (fun (n:nat) => fun (m:nat) => (((sym_eq_minus) (S m)) (fun (y:(nat -> nat)) => (forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) -> forall (p:nat), (le (S n) (S m)) -> logic.eq (nat) (plus (y (S n)) p) (minus (plus (S m) p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (m)) (fun (y:(nat -> nat)) => (forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) -> forall (p:nat), (le (S n) (S m)) -> logic.eq (nat) (plus (y (S n)) p) (minus (plus (S m) p) (S n)))) ((((sym_eq_minus_body_S) (m)) (fun (y:(nat -> nat)) => (forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) -> forall (p:nat), (le (S n) (S m)) -> logic.eq (nat) (plus (y (S n)) p) (minus (plus (S m) p) (S n)))) (fun (auto:forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) => (fun (p:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (S m)) (fun (q:nat) => minus m q)) (n)) (fun (y:nat) => (le (S n) (S m)) -> logic.eq (nat) (plus y p) (minus (plus (S m) p) (S n)))) ((((sym_eq_minus) (plus (S m) p)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (y (S n)))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (filter_nat_type (nat -> nat) minus_body (y p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (filter_nat_type (nat -> nat) minus_body (y p) (S n)))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (filter_nat_type (nat -> nat) minus_body (y p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (plus m p)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (y (S n)))) ((((eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((((eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((eq_plus) (S m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((sym_eq_minus_body_S) (plus m p)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (y (S n)))) (((((((sym_eq_match_nat_type_S) (nat)) (S (plus m p))) (fun (q:nat) => minus (plus m p) q)) (n)) (fun (y:nat) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) y)) (fun (auto':le (S n) (S m)) => (((auto) (p)) (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) (auto'))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n)))))))))))))))))))))))).
Definition minus_plus_m_m : forall (n:nat), forall (m:nat), logic.eq (nat) n (minus (plus n m) m) := fun (n:nat) => fun (m:nat) => ((((logic.eq_coerc) (logic.eq (nat) (plus (minus m m) n) (minus (plus m n) m))) (logic.eq (nat) n (minus (plus n m) m))) (((((plus_minus) (m)) (m)) (n)) ((le_n) (m)))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) (plus __ n) (minus (plus m n) m)) (logic.eq (nat) n (minus (plus n m) m)))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) __ (minus (plus m n) m)) (logic.eq (nat) n (minus (plus n m) m)))) (((((((logic.rewrite_r) (nat)) (plus n m)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) n (minus __ m)) (logic.eq (nat) n (minus (plus n m) m)))) (((logic.refl) (Prop)) (logic.eq (nat) n (minus (plus n m) m)))) (plus m n)) (((commutative_plus) (m)) (n)))) (plus O n)) ((plus_O_n) (n)))) (minus m m)) ((minus_n_n) (m))).
Definition plus_minus_m_m : forall (n:nat), forall (m:nat), (le m n) -> logic.eq (nat) n (plus (minus n m) m) := fun (n:nat) => fun (m:nat) => fun (lemn:le m n) => (((((logic.sym_eq) (nat)) (plus (minus n m) m)) (n)) (((((logic.eq_coerc) (logic.eq (nat) (plus (minus n m) m) (minus (plus n m) m))) (logic.eq (nat) (plus (minus n m) m) n)) (((((plus_minus) (m)) (n)) (m)) (lemn))) (((((((logic.rewrite_r) (nat)) (plus m (minus n m))) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) (plus (minus n m) m) (minus (plus n m) m)) (logic.eq (nat) __ n))) (((((((logic.rewrite_r) (nat)) (plus m (minus n m))) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) __ (minus (plus n m) m)) (logic.eq (nat) (plus m (minus n m)) n))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) (plus m (minus n m)) __) (logic.eq (nat) (plus m (minus n m)) n))) (((logic.refl) (Prop)) (logic.eq (nat) (plus m (minus n m)) n))) (minus (plus n m) m)) (((minus_plus_m_m) (n)) (m)))) (plus (minus n m) m)) (((commutative_plus) (minus n m)) (m)))) (plus (minus n m) m)) (((commutative_plus) (minus n m)) (m))))).
Definition minus_to_plus : forall (n:nat), forall (m:nat), forall (p:nat), (le m n) -> (logic.eq (nat) (minus n m) p) -> logic.eq (nat) n (plus m p) := fun (n:nat) => fun (m:nat) => fun (p:nat) => fun (lemn:le m n) => (fun (eqp:logic.eq (nat) (minus n m) p) => (((((logic.eq_coerc) (logic.eq (nat) n (plus (minus n m) m))) (logic.eq (nat) n (plus m p))) ((((plus_minus_m_m) (n)) (m)) (lemn))) (((((((logic.rewrite_r) (nat)) (plus m (minus n m))) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) n __) (logic.eq (nat) n (plus m p)))) (((((((logic.rewrite_r) (nat)) (p)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) n (plus m __)) (logic.eq (nat) n (plus m p)))) (((logic.refl) (Prop)) (logic.eq (nat) n (plus m p)))) (minus n m)) (eqp))) (plus (minus n m) m)) (((commutative_plus) (minus n m)) (m))))).
Definition plus_to_minus : forall (n:nat), forall (m:nat), forall (p:nat), (logic.eq (nat) n (plus m p)) -> logic.eq (nat) (minus n m) p := fun (n:nat) => fun (m:nat) => fun (p:nat) => fun (eqp:logic.eq (nat) n (plus m p)) => (((((logic.sym_eq) (nat)) (p)) (minus n m)) (((((logic.eq_coerc) (logic.eq (nat) p (minus (plus p m) m))) (logic.eq (nat) p (minus n m))) (((minus_plus_m_m) (p)) (m))) (((((((logic.rewrite_r) (nat)) (plus m p)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) p (minus __ m)) (logic.eq (nat) p (minus n m)))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (logic.eq (nat) p (minus __ m)) (logic.eq (nat) p (minus n m)))) (((logic.refl) (Prop)) (logic.eq (nat) p (minus n m)))) (plus m p)) (eqp))) (plus p m)) (((commutative_plus) (p)) (m))))).
Definition monotonic_le_minus_l : forall (p:nat), forall (q:nat), forall (n:nat), (le q p) -> le (minus q n) (minus p n) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => forall (n:nat), (le _0 __) -> le (minus _0 n) (minus __ n))) (fun (p:nat) => fun (q:nat) => fun (lePO:le p O) => (((((le_n_O_elim) (p)) (lePO)) (fun (__:nat) => le (minus __ q) (minus O q))) ((le_n) (minus O q))))) (fun (p:nat) => fun (q:nat) => (((sym_eq_minus) (S p)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (y q))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (p)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (y q))) ((((sym_eq_minus_body_S) (p)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (y q))) (((eq_plus_body_O) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (y (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) (((((eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (y (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) ((((eq_plus) (O)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (y (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) (((eq_minus_body_O) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (plus (y (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) (((((eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (plus (y (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) ((((eq_minus) (O)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (plus (y (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) (((eq_minus_body_O) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (plus (minus (y q) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) (((((eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (plus (minus (y q) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) ((((eq_minus) (O)) (fun (y:(nat -> nat)) => (le O (S p)) -> le (minus O q) (plus (minus (y q) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))) (fun (auto:le O (S p)) => (((le_plus_minus_m_m) (minus O q)) (match_nat_type (nat) (S p) (fun (q0:nat) => minus p q0) q)))))))))))))))) (fun (p:nat) => fun (q:nat) => fun (Hind:forall (n0:nat), (le q p) -> le (minus q n0) (minus p n0)) => (fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => (le (S q) (S p)) -> le (minus (S q) __) (minus (S p) __))) ((((sym_eq_minus) (S q)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (y O) (minus (S p) O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (q)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (y O) (minus (S p) O))) ((((sym_eq_minus_body_S) (q)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (y O) (minus (S p) O))) ((((((sym_eq_match_nat_type_O) (nat)) (S q)) (fun (z:nat) => minus q z)) (fun (y:nat) => (le (S q) (S p)) -> le y (minus (S p) O))) ((((sym_eq_minus) (S p)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (S q) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (p)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (S q) (y O))) ((((sym_eq_minus_body_S) (p)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (S q) (y O))) ((((((sym_eq_match_nat_type_O) (nat)) (S p)) (fun (q0:nat) => minus p q0)) (fun (y:nat) => (le (S q) (S p)) -> le (S q) y)) (fun (auto:le (S q) (S p)) => (auto))))))))))) ((((sym_eq_minus) (S q)) (fun (y:(nat -> nat)) => forall (a:nat), (le (S q) (S p)) -> le (y (S a)) (minus (S p) (S a)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (q)) (fun (y:(nat -> nat)) => forall (a:nat), (le (S q) (S p)) -> le (y (S a)) (minus (S p) (S a)))) ((((sym_eq_minus_body_S) (q)) (fun (y:(nat -> nat)) => forall (a:nat), (le (S q) (S p)) -> le (y (S a)) (minus (S p) (S a)))) (fun (a:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (S q)) (fun (z:nat) => minus q z)) (a)) (fun (y:nat) => (le (S q) (S p)) -> le y (minus (S p) (S a)))) ((((sym_eq_minus) (S p)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (minus q a) (y (S a)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (p)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (minus q a) (y (S a)))) ((((sym_eq_minus_body_S) (p)) (fun (y:(nat -> nat)) => (le (S q) (S p)) -> le (minus q a) (y (S a)))) (((((((sym_eq_match_nat_type_S) (nat)) (S p)) (fun (q0:nat) => minus p q0)) (a)) (fun (y:nat) => (le (S q) (S p)) -> le (minus q a) y)) (fun (leSS:le (S q) (S p)) => (((Hind) (a)) (((((logic.eq_coerc) (le (pred (S q)) (pred (S p)))) (le q p)) ((((monotonic_pred) (S q)) (S p)) (leSS))) (((((((logic.rewrite_l) (nat)) (q)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S p))) (le q p))) (((((((logic.rewrite_l) (nat)) (p)) (fun (__:nat) => logic.eq (Prop) (le q __) (le q p))) (((logic.refl) (Prop)) (le q p))) (pred (S p))) ((pred_Sn) (p)))) (pred (S q))) ((pred_Sn) (q))))))))))))))) (n))).
Definition le_plus_to_minus : forall (n:nat), forall (m:nat), forall (p:nat), (le n (plus p m)) -> le (minus n m) p := fun (n:nat) => fun (m:nat) => fun (p:nat) => fun (lep:le n (plus p m)) => (((((logic.eq_coerc) (le (minus n m) (minus (plus p m) m))) (le (minus n m) p)) (((((monotonic_le_minus_l) (plus p m)) (n)) (m)) (lep))) (((((((logic.rewrite_l) (nat)) (p)) (fun (__:nat) => logic.eq (Prop) (le (minus n m) __) (le (minus n m) p))) (((logic.refl) (Prop)) (le (minus n m) p))) (minus (plus p m) m)) (((minus_plus_m_m) (p)) (m)))).
Definition monotonic_le_minus_r : forall (p:nat), forall (q:nat), forall (n:nat), (le q p) -> le (minus n p) (minus n q) := fun (p:nat) => fun (q:nat) => fun (n:nat) => fun (lepq:le q p) => (((((le_plus_to_minus) (n)) (p)) (minus n q)) ((((((transitive_le) (n)) (plus (minus n q) q)) (plus (minus n q) p)) (((le_plus_minus_m_m) (n)) (q))) (((((monotonic_le_plus_r) (minus n q)) (q)) (p)) (lepq)))).
Definition eq_minus_O : forall (n:nat), forall (m:nat), (le n m) -> logic.eq (nat) (minus n m) O := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((le_n_O_elim) (minus n m)) (((((logic.eq_coerc) (le (minus n m) (minus n n))) (le (minus n m) O)) (((((monotonic_le_minus_r) (m)) (n)) (n)) (lenm))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (Prop) (le (minus n m) __) (le (minus n m) O))) (((logic.refl) (Prop)) (le (minus n m) O))) (minus n n)) ((minus_n_n) (n))))) (fun (__:nat) => logic.eq (nat) __ O)) (((logic.refl) (nat)) (O))).
Definition minus_plus : forall (n:nat), forall (m:nat), forall (p:nat), logic.eq (nat) (minus (minus n m) p) (minus n (plus m p)) := fun (n:nat) => fun (m:nat) => fun (p:nat) => ((((((connectives.match_Or_prop) (le (plus m p) n)) (connectives.Not (le (plus m p) n))) (logic.eq (nat) (minus (minus n m) p) (minus n (plus m p)))) (fun (Hlt:le (plus m p) n) => (((((plus_to_minus) (minus n m)) (p)) (minus n (plus m p))) (((((plus_to_minus) (n)) (m)) (plus p (minus n (plus m p)))) (((((((logic.eq_ind) (nat)) (plus (plus m p) (minus n (plus m p)))) (fun (x_1:nat) => logic.eq (nat) n x_1)) ((((((minus_to_plus) (n)) (plus m p)) (minus n (plus m p))) (Hlt)) (((logic.refl) (nat)) (minus n (plus m p))))) (plus m (plus p (minus n (plus m p))))) ((((associative_plus) (m)) (p)) (minus n (plus m p)))))))) (fun (Hlt:connectives.Not (le (plus m p) n)) => (((((((logic.eq_ind_r) (nat)) (O)) (fun (x:nat) => logic.eq (nat) x (minus n (plus m p)))) (((((logic.sym_eq) (nat)) (minus n (plus m p))) (O)) (((((logic.eq_coerc) (logic.eq (nat) (minus n (plus m p)) O)) (logic.eq (nat) (minus n (plus m p)) O)) ((((eq_minus_O) (n)) (plus m p)) ((((((transitive_le) (n)) (S n)) (plus m p)) ((le_n_Sn) (n))) ((((not_le_to_lt) (plus m p)) (n)) (Hlt))))) (((logic.refl) (Prop)) (logic.eq (nat) (minus n (plus m p)) O))))) (minus (minus n m) p)) ((((eq_minus_O) (minus n m)) (p)) (((((logic.eq_coerc) (le (minus n m) (minus (plus p m) m))) (le (minus n m) p)) (((((monotonic_le_minus_l) (plus p m)) (n)) (m)) (((((logic.eq_coerc) (le n (plus m p))) (le n (plus p m))) ((((((transitive_le) (n)) (S n)) (plus m p)) ((le_n_Sn) (n))) ((((not_le_to_lt) (plus m p)) (n)) (Hlt)))) (((((((logic.rewrite_r) (nat)) (plus m p)) (fun (__:nat) => logic.eq (Prop) (le n (plus m p)) (le n __))) (((logic.refl) (Prop)) (le n (plus m p)))) (plus p m)) (((commutative_plus) (p)) (m)))))) (((((((logic.rewrite_l) (nat)) (p)) (fun (__:nat) => logic.eq (Prop) (le (minus n m) __) (le (minus n m) p))) (((logic.refl) (Prop)) (le (minus n m) p))) (minus (plus p m) m)) (((minus_plus_m_m) (p)) (m)))))))) (((decidable_le) (plus m p)) (n)).
Definition minus_le_minus_minus_comm : forall (b:nat), forall (c:nat), forall (a:nat), (le c b) -> logic.eq (nat) (minus a (minus b c)) (minus (plus a c) b) := fun (b:nat) => fun (c:nat) => fun (a:nat) => fun (H:le c b) => (((((((logic.eq_ind_r) (nat)) (plus (minus b c) c)) (fun (x:nat) => logic.eq (nat) (minus a (minus b c)) (minus (plus a c) x))) (((((((logic.rewrite_r) (nat)) (plus c a)) (fun (__:nat) => logic.eq (nat) (minus a (minus b c)) (minus __ (plus (minus b c) c)))) (((((((logic.rewrite_r) (nat)) (plus c (minus b c))) (fun (__:nat) => logic.eq (nat) (minus a (minus b c)) (minus (plus c a) __))) (((((((logic.rewrite_l) (nat)) (minus (minus (plus c a) c) (minus b c))) (fun (__:nat) => logic.eq (nat) (minus a (minus b c)) __)) (((((((logic.rewrite_r) (nat)) (minus (plus c a) c)) (fun (__:nat) => logic.eq (nat) (minus __ (minus b c)) (minus (minus (plus c a) c) (minus b c)))) (((logic.refl) (nat)) (minus (minus (plus c a) c) (minus b c)))) (a)) (((((((logic.rewrite_l) (nat)) (plus a c)) (fun (__:nat) => logic.eq (nat) a (minus __ c))) (((minus_plus_m_m) (a)) (c))) (plus c a)) (((commutative_plus) (a)) (c))))) (minus (plus c a) (plus c (minus b c)))) ((((minus_plus) (plus c a)) (c)) (minus b c)))) (plus (minus b c) c)) (((commutative_plus) (minus b c)) (c)))) (plus a c)) (((commutative_plus) (a)) (c)))) (b)) ((((plus_minus_m_m) (b)) (c)) (H))).
